#property copyright "Copyright  2014, TLP"
#property link      "google.com"

//#include <stdlib.mqh>
#import "stdlib.ex4"
   string ErrorDescription(int a0); // DA69CBAFF4D38B87377667EEC549DE5A
#import

string G_name_76 = "lblCloseAllOrders";
int G_slippage_84 = 0;

int deinit() {
   ObjectDelete(G_name_76);
   return (0);
}

int start() {
   CloseAllOrders();
   return (0);
}

void CloseAllSell() {
   int datetime_12;
   int error_16;
   int order_total_4 = OrdersTotal();
   if (order_total_4 > 0) {
      for (int pos_0 = order_total_4 - 1; pos_0 >= 0; pos_0--) {
         if (OrderSelect(pos_0, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderType() == OP_SELL) {
               while (IsTradeContextBusy()) Sleep(1000);
               datetime_12 = TimeCurrent();
               RefreshRates();
               for (int is_closed_8 = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), G_slippage_84, Yellow); (!is_closed_8) && TimeCurrent() - datetime_12 <= 120 &&
                  !IsTesting(); is_closed_8 = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), G_slippage_84, Yellow)) {
                  Sleep(1000);
                  while (IsTradeContextBusy()) Sleep(500);
                  RefreshRates();
               }
               if (!is_closed_8) {
                  error_16 = GetLastError();
                  Print("   SELL #" + OrderTicket() + " " + ErrorDescription(error_16));
               }
            }
         } else Print("    :" + ErrorDescription(error_16));
      }
   }
}

void CloseAllBuy() {
   int datetime_12;
   int error_16;
   int order_total_4 = OrdersTotal();
   if (order_total_4 > 0) {
      for (int pos_0 = order_total_4 - 1; pos_0 >= 0; pos_0--) {
         if (OrderSelect(pos_0, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderType() == OP_BUY) {
               while (IsTradeContextBusy()) Sleep(1000);
               datetime_12 = TimeCurrent();
               RefreshRates();
               for (int is_closed_8 = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), G_slippage_84, Yellow); (!is_closed_8) && TimeCurrent() - datetime_12 <= 120 &&
                  !IsTesting(); is_closed_8 = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), G_slippage_84, Yellow)) {
                  Sleep(1000);
                  while (IsTradeContextBusy()) Sleep(1000);
                  RefreshRates();
               }
               if (!is_closed_8) {
                  error_16 = GetLastError();
                  Print("   BUY #" + OrderTicket() + " " + ErrorDescription(error_16));
               }
            }
         } else Print("    :" + ErrorDescription(error_16));
      }
   }
}

void DeletePendingOrders() {
   for (int order_total_0 = OrdersTotal(); order_total_0 >= 0; order_total_0--) {
      if (!OrderSelect(order_total_0, SELECT_BY_POS, MODE_TRADES)) Print("   .  " + ErrorDescription(GetLastError()));
      else
         if (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP || OrderType() == OP_BUYLIMIT || OrderType() == OP_SELLLIMIT) OrderDelete(OrderTicket());
   }
}

void CloseAllOrders() {
   while (OrdersTotal() > 0) {
      CloseAllBuy();
      CloseAllSell();
      DeletePendingOrders();
      Sleep(1000);
   }
}
